checkRoute();

function checkRoute() {
  let jwt_token = get_jwt_token();
  if(jwt_token == undefined) {
    window.location.replace("login.html");
  }
  axios({
    method: 'post',
    url: 'https://www.choozmo.com:8887/user_profile',
    headers: { 
        'accept': 'text/html',
        'Authorization': `Bearer ${jwt_token}`
     }
  }).then(res => {
    console.log(res.data);
    if(res.status !== 200) {
      window.location.replace("login.html");
    }
    var userName='';
    userName+=' <h2 class="user-name text-white mt-4 fw-bold">Hello,'+res.data.user_info.userName+'</h2>';
    $('.userName').html(userName);
  }).catch(err => {
    console.log(err);
  });
}

const btnLoginPage = document.querySelector('.btn-login');
const btnUserProfile = document.querySelector('.btn-userProfile');
const btnLogout = document.querySelector('.btn-logout');

function loginControl() {
    btnLoginPage.style.display = 'none';
    btnLogout.style.display = 'block';
    btnUserProfile.style.display = 'block';
}

loginControl();


var client_id = Date.now();
var tooltipTriggerList = [].slice.call(document.querySelectorAll('[data-bs-toggle="tooltip"]'))
var tooltipList = tooltipTriggerList.map(function (tooltipTriggerEl) {
  return new bootstrap.Tooltip(tooltipTriggerEl)
});
var myModal = new bootstrap.Modal(document.getElementById('history'), {
  keyboard: false
})
var avatarModal = new bootstrap.Modal(document.getElementById('avatarmega'), {
  keyboard: false
})
var modalImg = document.querySelector("#avatarmega .modal-img");
var modalTitle = document.querySelector("#avatarmega .modal-title");
var avatarSelector = document.getElementById("avatar");
var card = document.getElementsByClassName('card');
card = [...card];
avatarSelector.addEventListener('change', avatarChange);
avatarChange();

function addCardListener() {
  for (let i = 0; i < card.length; i++) {
    card[i].addEventListener('click', openavatarModel);
  }
}

addCardListener();

function avatarChange() {
  var value = avatarSelector.options[avatarSelector.selectedIndex].text;
  $('.owl-carousel').trigger('to.owl.carousel', avatarSelector.selectedIndex);
  for (let i = 0; i < card.length; i++) {
    card[i].classList.remove('active');
    if (card[i].dataset.avatar == value) {
      card[i].classList.add('active');
    }
  }
}

function openavatarModel() {
  console.log(this.dataset.img);
  modalImg.setAttribute("src", `static/img/${this.dataset.img}.webp`);
  modalTitle.textContent = `${this.dataset.avatar}`;
  avatarModal.show();
}

$('input[type=file]').on('change', prepareUpload);
function prepareUpload(event) {
  files = event.target.files;
  var data = new FormData();
  //data.append('file', $('.img_up1').prop('files')[0]);
  data.append('file', files[0]);
  // append other variables to data if you want: data.append('field_name_x', field_value_x);
  $(this).next().text('');
  $(this).next().html('<img src="static/img/Spinner-1s-181px.gif">');
  $.ajax({
    type: 'POST',
    processData: false, // important
    contentType: false, // important
    data: data,
    url: 'https://www.choozmo.com:8887/uploadfile',
    dataType: 'json',
    success: function (jsonData) {
      event.target.previousSibling.value = jsonData.msg;
      $(this).prev().val(jsonData.msg);
      event.target.nextSibling.innerHTML = '';
      event.target.nextSibling.textContent = 'Upload';
      //console.log($(this).next());
      //$(this).next().html('上傳檔案');
      //$(this).next().text('上傳檔案');
    },
    error: function (error) {
      event.target.nextSibling.innerHTML = '';
      event.target.nextSibling.textContent = '上傳檔案';
      alert('圖片錯誤');
    }
  });
}
const button = document.querySelector('.next');

$(".next").click(function () {
  button.setAttribute('disabled', '');
  setTimeout(function () {
    button.removeAttribute('disabled')
  }, 8000);
  avatar = $('.avatar').val();
  name_title = $('.title_new').val();
  txtARR = [];
  imgARR = [];
  sublineARR = [];
  var step;
  let contentIdx = document.querySelectorAll(".txtsrc").length;
  for (let i = 1; i < (contentIdx + 1); i++) {
    if ($(`.txtsrc${i}`).val() != "") {
      txtARR.push($(`.txtsrc${i}`).val())
    }
  }
  let sublineIdx = document.querySelectorAll(".subsrc").length;
  for (let i = 1; i < (sublineIdx + 1); i++) {
    if ($(`.subsrc${i}`).val() != "") {
        sublineARR.push($(`.subsrc${i}`).val())
    }
  }
  let imgIdx = document.querySelectorAll(".imgsrc").length;
  for (let i = 1; i < (imgIdx + 1); i++) {
    if ($(`.imgsrc${i}`).val() != "") {
      imgARR.push($(`.imgsrc${i}`).val())
    }
  }
  dataOBJ = { "name": name_title, "text_content": txtARR, "image_urls": imgARR, "sub_titles": sublineARR, "avatar": avatar };
  objstr = JSON.stringify(dataOBJ);
  console.log(dataOBJ);
  jwt_token =  get_jwt_token();
  var xhr = new XMLHttpRequest();
  xhr.open("POST", "https://www.choozmo.com:8887/make_anchor_video_eng");
  xhr.setRequestHeader("accept", "application/json");
  xhr.setRequestHeader("Authorization","Bearer "+jwt_token)
  xhr.setRequestHeader("Content-Type", "application/json");
  xhr.onreadystatechange = function () {
    if (xhr.readyState === 4) {
      responseOBJ = JSON.parse(xhr.responseText);
      if (responseOBJ.msg=='ok')
      {
        Swal.fire({
          title: "Data Submitted Successfully!",
          icon: 'success',
          text: 'We are working on your video! It might take minutes to get your video.',
          confirmButtonColor: '#3085d6',
        });
      }
      else{
        Swal.fire({
          title: "Oops! Some error occurred!",
          icon: 'error',
          text: responseOBJ.msg,
          confirmButtonColor: '#3085d6',
        });
      }
      
    }
  };
  var data = renderXHR_data(dataOBJ)
  console.log(data)
  result = xhr.send(objstr);
});


var loaded_data = ''
function openNav() {
  document.getElementById("mySidenav").style.width = "250px";
  document.querySelector('.loader').style.display = "block";
  let jwt_token = get_jwt_token();
  axios({
    method: 'post',
    url: 'https://www.choozmo.com:8887/history_input',
    headers: { 
        'accept': 'application/json',
        'Authorization': `Bearer ${jwt_token}`
     }
  }).then(res => {
    console.log(res.data);
    loaded_data = res.data;
    for (var obj of loaded_data) {
      var historyList = document.querySelector('.historyList');
      var list = document.createElement('li');
      list.id = obj.id;
      // div-imgfr
      var divImgfr = document.createElement('div');
      divImgfr.classList.add('item_imgfr');
      var img = document.createElement('img');
      img.setAttribute('src', obj['image_urls'][0]);
      divImgfr.appendChild(img);
      // div-content
      var contentBox = document.createElement('div');
      contentBox.classList.add('content-box');
      var boxTitle = document.createElement('p');
      boxTitle.classList.add('box-title');
      boxTitle.textContent = obj.name;
      boxTitle.id = obj.id;
      boxTitle.setAttribute('onclick', 'load_data()');

      var boxLink = document.createElement('span');
      boxLink.classList.add('box-link');
      boxLink.setAttribute("data-url", obj.link);
      boxLink.setAttribute('onclick', 'view()');
      boxLink.innerHTML = '<i class="fas fa-play-circle me-1"></i>觀看影片';
      contentBox.appendChild(boxTitle);
      contentBox.appendChild(boxLink);
      list.classList.add("historyList-item");
      list.setAttribute('onclick', 'load_data()');
      list.appendChild(divImgfr);
      list.appendChild(contentBox);
      historyList.appendChild(list);
    }
    document.querySelector('.loader').style.display = "none";
  
  }).catch(err => {
    console.log(err);
  });
}
function closeNav() {
  document.getElementById("mySidenav").style.width = "250px";
}

function view() {
  event.stopPropagation();
  console.log(event.target);
  if (event.target.nodeName === 'I') {
    return;
  } else {
    window.open(`http://${event.target.dataset.url}`, '_blank');
  }
}

function renderXHR_data(jsonObj) {
  XHRstring = ''
  for (const [key, value] of Object.entries(jsonObj)) {
    console.log(value)
    if (typeof (value) == "object") {
      XHRstring += (key+'=['+value.join(',')+']&')
    }
    else {
      XHRstring += (key + '=' + value + '&')
    }
  }
  XHRstring = XHRstring.substring(0, XHRstring.length - 1);
  return XHRstring
}

function get_jwt_token(){
  jwt_raw = document.cookie.split(';').filter(s=>s.includes('jwt_token'))[0];
  if(!jwt_raw) {return}
  return jwt_raw.split('=')[1];
}

function load_data() {
  var title = document.getElementById("title");
  var linker = document.getElementById("linker");

  myModal.hide()
  tid = event.srcElement.id
  console.log(tid);
  linker.setAttribute('href', `http://${loaded_data.find(item => item.id == tid).link}`)
  linker.setAttribute('target', '_blank')
  $("#linker").html(`http://${loaded_data.find(item => item.id == tid).link}`)
  $("#linker").show();
  $(".linker__box").show();

  let historyItem = loaded_data.filter(item => item.id == tid)[0];
  console.log(historyItem);
  $(".title_new").val(loaded_data.find(item => item.id == tid).name);

  let txtlength = historyItem.text_content.length;
  let imglength = historyItem.image_urls.length;
  let sublinelength = historyItem.sub_titles.length;

  subtitleInputs.innerHTML = '';
  imgInputs.innerHTML = '';
  sublineInputs.innerHTML = '';

  for (let i = 0; i < txtlength; i++) {
    var txtinput = document.createElement("input");
    txtinput.setAttribute('type', 'text');
    txtinput.setAttribute('name', `t${i + 1}`);
    txtinput.value = historyItem.text_content[i];
    txtinput.setAttribute('placeholder', `${i + 1}`);
    txtinput.classList.add('txtsrc', `txtsrc${i + 1}`)
    subtitleInputs.appendChild(txtinput);
  }
  for (let i = 0; i < sublinelength; i++) {
    var txtinput = document.createElement("input");
    txtinput.setAttribute('type', 'text');
    txtinput.setAttribute('name', `s${i + 1}`);
    txtinput.value = historyItem.sub_titles[i];
    txtinput.setAttribute('placeholder', `${i + 1}`);
    txtinput.classList.add('subsrc', `subsrc${i + 1}`)
    sublineInputs.appendChild(txtinput);
  }
  for (let i = 0; i < imglength; i++) {
    var imginput = document.createElement("input");
    imginput.setAttribute('type', 'text');
    imginput.setAttribute('name', `m${i + 1}`);
    imginput.classList.add('imgsrc', `imgsrc${i + 1}`);
    imginput.value = historyItem.image_urls[i];
    imginput.setAttribute('placeholder', `${i + 1}`);
    imgInputs.appendChild(imginput);

    var imgupload = document.createElement("input");
    imgupload.setAttribute('id', `img${i + 1}`);
    imgupload.setAttribute('type', `file`);
    imgupload.classList.add('img_uploader', 'img_up');
    imgInputs.appendChild(imgupload);
    var imguploadlabel = document.createElement("label");
    imguploadlabel.setAttribute('for', `img${i + 1}`);
    imguploadlabel.classList.add('upload-btn');
    imguploadlabel.textContent = 'Upload';
    imgInputs.appendChild(imguploadlabel);
  }

}

var subtitleInputs = document.querySelector(".subtitle-inputs");
var sublineInputs = document.querySelector(".subline-inputs");
var imgInputs = document.querySelector(".img-inputs");
let length = 5;
function initial() {
  for (let i = 0; i < length; i++) {
    rendertxtBlock(i + 1);
    renderimgBlock(i + 1);
    renderSublineBlock(i +1);
  }
  console.log(document.querySelectorAll(".txtsrc").length + 1);
}

initial();

var addbtn = document.querySelector(".add");
var addimgbtn = document.querySelector(".addimg");
var addSubline = document.querySelector('.add-subline');

addbtn.addEventListener('click', addtxtBlock);
addimgbtn.addEventListener('click', addimgBlock);
addSubline.addEventListener('click', addsubBlock);


function addtxtBlock() {
  let newIdx = document.querySelectorAll(".txtsrc").length + 1;
  rendertxtBlock(newIdx);
}

function addsubBlock() {
    let newIdx = document.querySelectorAll(".subsrc").length + 1;
    renderSublineBlock(newIdx);
  }

function addimgBlock() {
  let newimgIdx = document.querySelectorAll(".imgsrc").length + 1;
  renderimgBlock(newimgIdx);
}

function rendertxtBlock(i) {
  var txtinput = document.createElement("input");
  txtinput.setAttribute('type', 'text');
  txtinput.setAttribute('name', `t${i}`);
  txtinput.value = "";
  txtinput.setAttribute('placeholder', `${i}`);
  txtinput.classList.add('txtsrc', `txtsrc${i}`)
  subtitleInputs.appendChild(txtinput);
}

function renderSublineBlock(i) {
    var txtinput = document.createElement("input");
  txtinput.setAttribute('type', 'text');
  txtinput.setAttribute('name', `s${i}`);
  txtinput.value = "";
  txtinput.setAttribute('placeholder', `${i}`);
  txtinput.classList.add('subsrc', `subsrc${i}`)
  sublineInputs.appendChild(txtinput);
}

function renderimgBlock(i) {
  var imginput = document.createElement("input");
  imginput.setAttribute('type', 'text');
  imginput.setAttribute('name', `m${i}`);
  imginput.classList.add('imgsrc', `imgsrc${i}`);
  imginput.value = "";
  imginput.setAttribute('placeholder', `${i}`);
  imgInputs.appendChild(imginput);

  var imgupload = document.createElement("input");
  imgupload.setAttribute('id', `img${i}`);
  imgupload.setAttribute('type', `file`);
  imgupload.classList.add('img_uploader', 'img_up');
  imgInputs.appendChild(imgupload);
  var imguploadlabel = document.createElement("label");
  imguploadlabel.setAttribute('for', `img${i}`);
  imguploadlabel.classList.add('upload-btn');
  imguploadlabel.textContent = 'Upload';
  imgInputs.appendChild(imguploadlabel);
  $('input[type=file]').on('change', prepareUpload);
}
